{$APPTYPE CONSOLE}
uses
  mmsystem,windows;

var
in_c,out_c:integer;
i:integer;
in_caps:MidiInCaps;
out_caps:MidiOutCaps;

procedure play(filename:pchar);
var
wDeviceID:integer;
openparms:MCI_OPEN_PARMS;
playparms:MCI_PLAY_PARMS;
begin
openparms.lpstrDeviceType:='sequencer';
openparms.lpstrElementName:=filename;
mciSendCommand(0,MCI_OPEN,MCI_OPEN_TYPE or MCI_OPEN_ELEMENT,DWORD(@openparms));
wDeviceID:=openparms.wDeviceID;
mciSendCommand(wDeviceID,MCI_PLAY,0,DWORD(@playparms));
end;

begin
in_c:=midiInGetNumDevs;
out_c:=midiOutGetNumDevs;
writeln('Urzadzenia wejsciowe: ',in_c);
writeln('Urzadzenia wyjsciowe: ',out_c);
writeln;
  for i:=0 to in_c-1 do
  begin
  writeln('Urzadzenie wejsciowe[',i,']');
  midiInGetDevCaps(i,@in_caps,sizeof(in_caps));
  writeln('Nazwa: ',in_caps.szpnamE);
  writeln('Wersja: ',HIBYTE(in_caps.vDriverVersion),'.',LOBYTE(in_caps.vDriverVersion));
  end;
  for i:=0 to out_c-1 do
  begin
  writeln('Urzadzenie wyjsciowe[',i,']');
  midiOutGetDevCaps(i,@out_caps,sizeof(out_caps));
  writeln('Nazwa: ',out_caps.szPName);
  writeln('Wersja: ',HIBYTE(out_caps.vDriverVersion),'.',LOBYTE(out_caps.vDriverVersion));
  write('Typ: ');
    if (out_caps.wTechnology=MOD_MIDIPORT) then
    writeln('MIDI hardware port')
    else if (out_caps.wTechnology=MOD_SYNTH) then
    writeln('Synthesizer')
    else if (out_caps.wTechnology=MOD_SQSYNTH) then
    writeln('Squarewave synthesizer')
    else if (out_caps.wTechnology=MOD_FMSYNTH) then
    writeln('FM synthesizer')
    else if (out_caps.wTechnology=MOD_MAPPER) then
    writeln('Microsoft MIDI mapper')
    else if (out_caps.wTechnology=6) then
    writeln('Hardware wavetable synthesizer')
    else if (out_caps.wTechnology=7) then
    writeln('Software synthesizer');
  writeln('Liczba glosow: ',out_caps.wVoices);
  writeln('Maksymalna liczba nut granych jednoczesnie: ',out_caps.wNotes);
  writeln;
  end;
play('d:\r.mid');
readln;
end.
